﻿ALTER PROCEDURE HM.GeneratePeriodicSaleReport
    @date DATE,
    @dkid INT
AS
DECLARE @PeriodicSaleReportId INT;
/* Procedura zakładająca nowy raport okresowy dla danego dnia
	- zwracamy id raportu okresowego 
*/
DECLARE @DepartmentId INT,
		@Department VARCHAR(40),
		@tUser VARCHAR(40),
        @PeriodicSaleReportDocumentType VARCHAR(30),
        @PeriodicSaleReportDocumentName VARCHAR(30),
        @periodicSaleReportNumerationSeries VARCHAR(30),
        @billingPeriod SMALLINT,
        @datefrom DATE,
        @dateTo DATE,
		@subtyp INT,
        @billingPeriodType INT,
        @billingPeriodSerie INT,
        @charakter SMALLINT;

SELECT @DepartmentId = magazyn,@tUser=users.LoginName, @subtyp = subtyp
FROM HM.DK dk
LEFT JOIN SSCommon.STUsers users ON dk.wystawil=users.id
WHERE dk.id = @dkid;

SELECT @billingPeriodType = billingPeriodType, @billingPeriodSerie = billingPeriodSerie FROM HM.TD WHERE kod = (SELECT typ_dk FROM HM.DK WHERE id = @dkid);
IF (ISNULL(@billingPeriodType, 0 ) <> 0 AND ISNULL(@billingPeriodSerie, 0 ) <> 0)
BEGIN
    SELECT @PeriodicSaleReportDocumentType = kod FROM HM.TD WHERE id = @billingPeriodType;
    SELECT @periodicSaleReportNumerationSeries = kod FROM HM.SD WHERE id = @billingPeriodSerie;
END

IF (ISNULL(@PeriodicSaleReportDocumentType, '') = '' AND ISNULL(@periodicSaleReportNumerationSeries, '') = '')
BEGIN
    SELECT @PeriodicSaleReportDocumentType = CASE WHEN @subtyp=50 THEN nazwisko ELSE naglowek END,
           @periodicSaleReportNumerationSeries =  CASE WHEN @subtyp=50 THEN imie ELSE nip END,
	       @department=kod
    FROM HM.KH
    WHERE id = @DepartmentId;
END

SELECT @billingPeriod = billingPeriod,
       @PeriodicSaleReportDocumentName = nazwa,
       @charakter = charakter
FROM HM.TD
WHERE kod = @PeriodicSaleReportDocumentType;


IF @billingPeriod = 1
BEGIN
    SET @datefrom = @date;
    SET @dateTo = @date;
END;
IF @billingPeriod = 2
BEGIN
    SELECT @datefrom = hm.fn_GetWeekStartDate(@date),
           @dateTo = hm.fn_GetWeekEndDate(@date);
END;
IF @billingPeriod = 3
BEGIN
    SELECT @datefrom = DATEADD(DAY, 1, EOMONTH(@date, -1)),
           @dateTo = EOMONTH(@date);
END;


SELECT @PeriodicSaleReportId = Id
FROM HM.PeriodicSaleReports
WHERE TRY_CONVERT(DATE, DateFrom) = @datefrom
      AND @dateTo = DateTo
      AND DepartmentId = @DepartmentId
      AND PeriodType = @billingPeriod
	  AND DocumentType = @PeriodicSaleReportDocumentType;

IF @PeriodicSaleReportId IS NULL
BEGIN

    DECLARE @szablon VARCHAR(100),
            @seria VARCHAR(10),
            @period INT,
            @schematKs VARCHAR(4);

    SELECT @szablon = szablon,
           @seria = seria.kod,
           @period = numeracja
    FROM HM.SD seria
    WHERE seria.kod = @periodicSaleReportNumerationSeries;

    Select @schematKs = sk.kod
    From hm.TD td
    INNER JOIN Hm.SK sk ON sk.id = td.idSchematKs
    WHERE td.kod = @PeriodicSaleReportDocumentType

	DECLARE @CurrentPeriod SMALLINT;
	SET @CurrentPeriod = HM.hm_GetCurrPer(@period,@date,0);
    DECLARE @DocumentNumber INT;
    EXEC @DocumentNumber = HM.hm_GetSeriaNr @seria = @seria,  -- varchar(5)
                                            @seriadzial = 1,  -- int
                                            @okres = @CurrentPeriod, -- smallint
                                            @baseid = 17,     -- int
                                            @recid = 0;       -- int
    DECLARE @DocumentCode VARCHAR(30);



    /* Jeżeli takiego nie ma raportu okresowego na wskazany dzień to trzeba go utworzyć
	i polecieć z update a do tego potrzeba odpowiedniej serii i numeracji*/
    INSERT INTO HM.PeriodicSaleReports
    (
        Code,
        SerialNumber,
        SerialNumberDepartment,
        Serie,
        DepartmentId,
        DateFrom,
        DateTo,
        DocumentType,
        DocumentName,
        DocumentCharacter,
        Period,
        PeriodType,
        SageConnectStatus,
        EksportFK,
        Net,
        Vat,
        Gross, 
        SchematKs
    )
    VALUES
    (   HM.Hm_podajkod('', @DocumentNumber, @szablon, DAY(@date), MONTH(@date), YEAR(@date),@tUser , '', @DepartmentId,@department , 0, ''), -- Code - varchar(40)
        @DocumentNumber,                                                                                             -- SerialNumber - int
        1,                                                                                                           -- SerialNumberDepartment - int
        @seria,                                                                                                      -- Serie - varchar(10)
        @DepartmentId,                                                                                               -- DepartmentId - int
        @datefrom,                                                                                                   -- DateFrom - datetime
        @dateTo,                                                                                                     -- DateTo - datetime
        @PeriodicSaleReportDocumentType,                                                                             -- DocumentType - varchar(40)
        @PeriodicSaleReportDocumentName,
        @charakter,                                                                                                         -- DocumentCharacter - int
        @CurrentPeriod,                                                                                              -- Period - smallint
        @billingPeriod,                                                                                              -- PeriodType - smallint
        '',                                                                                                          -- SageConnectStatus - varchar(10)
        '',                                                                                                          -- EksportFK - varchar(10)
        0,                                                                                                           -- Net - decimal(14, 2)
        0,                                                                                                           -- Vat - decimal(14, 2)
        0,
        @schematKs                                                                                                   -- SchematKs (varchar(4))
        );

    SET @PeriodicSaleReportId = SCOPE_IDENTITY();

END;

EXEC HM.RecalculatePeriodicSaleReport @dkid, @PeriodicSaleReportId;